
void keyPressed() {
  if (key == 'S' || key == 's') {
    saveFrame("######.jpg");
  }
  if (key == '=' || key =='+') {
    presentYear++;
    interpolator[0].target(presentYear);
  }
  if (key == '-' || key =='_') {
    presentYear--;
    interpolator[0].target(presentYear);
  }
  if (key == 'F' || key =='f') {
    rotateFree = !rotateFree;
  }
  if (key == 'T' || key == 't') {
    autoRotate = !autoRotate;
  }

  if (key == '1') {
    viewMode = 1;
    cam.setDistance(1600);
    setRotationInterpolator(0, 0, 0);
  }
  if (key == '2') {
    viewMode = 2;
    setRotationInterpolator(0, -PI/2, 0);
    rotateFree = false;
  }
  if (key == '3') {
    viewMode = 3;
    setRotationInterpolator(-PI/2, -PI/2, 0);
    rotateFree = false;
  }
  if (key == '4') {
    whichSinToSee++;
    whichSinToSee = whichSinToSee % 8;
  }
  if (key == '5') {
    if (whichSinToSee == 0) whichSinToSee+=7;
    whichSinToSee--;
  }

  if (key == 'B' || key =='b') {
    showBook = !showBook;
  }
  if (key == 'V' || key =='v') {
    showVideo = !showVideo;
  }
  if (key == 'A' || key =='a') {
    showAudio = !showAudio;
  }
  if (key == 'Y' || key =='y') {
    showOtherYear = !showOtherYear;
  }
  if (key == 'H' || key == 'h') {
    showGUI = !showGUI;
  }
  if (key == 'C' || key == 'c') {
    for (int i =0; i<rowNums; i++) {
      l.getItem(i).put("state", false);
    }
  }
  if (key == 'P' || key == 'p') {
    onlyStillFrame = !onlyStillFrame;
  }
}

void setRotationInterpolator(float rx, float ry, float rz) {
  interpolator[1].set(cam.getRotations()[0]);
  interpolator[2].set(cam.getRotations()[1]);
  interpolator[3].set(cam.getRotations()[2]);
  interpolator[1].target(rx);
  interpolator[2].target(ry);
  interpolator[3].target(rz);
}